#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define MAXN 500005
#define MAXBIT 40
const ll INF = 1e18;
ll a[MAXN];
int cnt[MAXBIT];

int main()
{
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    for(int i = 0; i < n; i++)
    {
        cin >> a[i];
        for(int j = 0; j < MAXBIT; j++)
        {
            if(a[i]&(1LL<<j))
            {
                cnt[j]^=1;
            }
        }
    }
    ll ans = INF;
    for(int j = 0; j < MAXBIT; j++)
    {
        int cntt[MAXBIT];
        for(int i = 0; i < MAXBIT; i++)cntt[i]=cnt[i];
        ll s=0LL;
        for(int i = 0; i < n; i++)
        {
            if(!(a[i]&(1LL<<j)))
            {
                ll add = (1LL<<j);
                for(int k = 0; k < MAXBIT;k++)
                {
                    if(k==j)continue;
                    if(a[i]&(1LL<<k))
                    {
                        add=min(add,abs((1LL<<j)-(1<<k)));
                    }
                }
                for(int k = 0; k < MAXBIT; k++)
                {
                    if(k==j)continue;
                    if(a[i]&(1LL<<k))
                    {
                        if(add==abs((1LL<<j)-(1LL<<k)))
                        {
                            cntt[j]^=1;
                            break;
                        }
                    }
                }
                s+=add;
            }
        }
        if(n%2==1)
        {
            ans=min(ans,s);
        }
        else
        {
            bool fl = false;
            for(int k = 0; k < MAXBIT; k++)
            {
                if(cntt[k]==1)
                {
                    ans=min(ans,s);
                    fl=true;
                    break;
                }
            }
            if(fl)continue;
            ans=min(ans,s+1);
        }
    }
    cout << ans;
    return 0;
}